import { pascalSingular } from '../../../../../../utils/cases'
import * as R from 'ramda'
import {
  getEditComponent,
  getTsDefaultTypeValueExpression,
} from '../EntityEdit/DefaultEntityEdit'
import { getCompNamesToEditField } from '../../../../ui/componentNames/edit/getCompNamesToEditField'
import { EntityWideGenerationArgs } from '../../../../../args'
import { generatedWarning, pad1, pad } from '../../../../../utils'
import { getKeyField, isImageFileRef, isMarkdownField, isMultilineField } from '../../../../../metaUtils'

export const uiDefaultCreateTmpl = ({
  allEntities,
  entity,
  options,
}: EntityWideGenerationArgs) => {
  const fileRefFields = entity.fields.filter(isImageFileRef)
  const withFileRef = fileRefFields.length > 0

  const fieldsToImport = entity.fields
    .filter((f) => !f.hidden && f.showInCreate)
    .filter((f) => !fileRefFields.includes(f))
    // .filter(f => f.requiredOnInput || f.requiredOnInput === null)
    .filter((f) => f.name !== 'id' || !getKeyField(entity).autoGenerated)
  const dateFieldsToImport = fieldsToImport.filter((f) =>
    ['datetime', 'date'].includes(f.type)
  )
  const notDateFieldsToImport = fieldsToImport.filter(
    (f) => !['datetime', 'date'].includes(f.type)
  )
  const reactAdminImports: string[] = [
    'Create',
    'SimpleForm',
    'CreateProps',

    ...R.flatten(
      notDateFieldsToImport.map((f) => getCompNamesToEditField(f, allEntities))
    ),
  ]

  const hasHidden = entity.fields
    .filter((f) => !f.hidden && f.showInCreate)
    .filter((f) => f.name !== 'id')
    .some((f) => !(f.requiredOnInput || f.requiredOnInput === null))

  const fieldsToWorkWith = entity.fields
    .filter((f) => !f.hidden && f.showInCreate)

    // .filter(f => f.requiredOnInput || f.requiredOnInput === null)
    .filter((f) => f.name !== 'id' || !getKeyField(entity).autoGenerated)

  const dateFields = fieldsToWorkWith.filter((f) => f.requiredOnInput !== false && ['datetime', 'date'].includes(f.type))

  const initialValues = fieldsToWorkWith.filter((f) =>
    getTsDefaultTypeValueExpression(f)
  )

  return `/* eslint-disable max-len */
import React, {FC, useMemo, useCallback} from 'react';
import {
  ${R.uniq(reactAdminImports.map((el) => `${el},`)).join(`
  `)}
} from 'react-admin';${
    dateFieldsToImport.some((f) => f.type === 'datetime')
      ? `
import DateTimeInput from '../../../../uiLib/DateTimeInput';`
      : ''
  }${
    dateFieldsToImport.some((f) => f.type === 'date')
      ? `
import DateInput from '../../../../uiLib/DateInput';`
      : ''
  }${
    hasHidden
      ? `
import {useDebug} from '../../../../contexts/DebugContext';`
      : ''
  }
import {Grid} from '@mui/material';
import {yupResolver} from '@hookform/resolvers/yup';
import get${pascalSingular(entity.name)}Validation from '../get${pascalSingular(
    entity.name
  )}Validation';
import {LoadingContext} from '../../../../contexts/LoadingContext';
${
  withFileRef
    ? "import {FileInput} from '../../../../uiLib/file/FileInput';\n"
    : ''
}${options.breadcrumb ?
    "import {Breadcrumbs} from '../../../../raUiLib/Breadcrumbs';\n" : ''}
${
  options.skipWarningThisIsGenerated
    ? ''
    : `// ${generatedWarning}
`
}
const defaultValues = ${initialValues.length === 0 ? '{}' : `{
${initialValues.map(f => `${f.name}: ${getTsDefaultTypeValueExpression(f)},`).map(pad(1)).join('\n')}
}`};

const Default${pascalSingular(
    entity.name
  )}Create: FC<CreateProps> = (props: CreateProps) => {
${
  hasHidden
    ? `  const {debug} = useDebug();
`
    : ''
}  const resolver = useMemo(() => yupResolver(get${pascalSingular(
    entity.name
  )}Validation()), []);

  return (
    <Create
      redirect='show'
      {...props}
      transform={useCallback((data: any) => {
        const mergedData = {...defaultValues, ...data};
        return ${dateFields.length ? `{
          ...mergedData,${fieldsToWorkWith
    .filter((f) => f.requiredOnInput !== false && ['datetime', 'date'].includes(f.type))
    .map((f) => `
          ${f.name}: mergedData.${f.name} || null,`)
    .join('')}
        }` : 'mergedData'};
      }, [])}${
    options.breadcrumb ? '\n      actions={<Breadcrumbs />}' : ''
  }
    >
      <LoadingContext>
        <SimpleForm
          defaultValues={defaultValues}
          resolver={resolver}
        >
          <Grid container spacing={2}>
${fieldsToWorkWith
  .map((f) => {
    const comp = `<Grid item ${(isMarkdownField(f) || isMultilineField(f)) ? 'xs={12} sm={12} md={12} lg={12}': 'xs={12} sm={6} md={3} lg={2}'}>
${pad1(getEditComponent(entity, allEntities, f, 'create'))}
</Grid>`

    const debuggedComp =
      f.requiredOnInput || f.requiredOnInput === null
        ? comp
        : `{debug && ${comp}}`

    return pad(6)(debuggedComp)
  })
  .join('\n')}
          </Grid>
        </SimpleForm>
      </LoadingContext>
    </Create>
  );
};

export default Default${pascalSingular(entity.name)}Create;
`
}
